#include "MyEventProcessor.h"
#include <TCLAnalyzer.h>
#include <Event.h>
#include <FilterBufferDecoder.h>

int i=0;

MyEventProcessor::MyEventProcessor(int ourId, int base) // Object Constructor
{
  nOurId =ourId;        // Id tag that will be unpacking
  Base = base;          // starting index for storing data in rbuf array
}

Bool_t MyEventProcessor::operator()(const Address_t pEvent, CEvent& rEvent,
				    CAnalyzer& rAnalyzer, CBufferDecoder& rDecoder)
{
  TranslatorPointer<UShort_t> p(*(rDecoder.getBufferTranslator()), pEvent);
  CTclAnalyzer& rAna((CTclAnalyzer&)rAnalyzer);

  UShort_t nWords=*p++;           // get number of words in the packet
  rAna.SetEventSize(nWords*sizeof(UShort_t));
  nWords--;

  while(nWords)                  // Search packet for ID tag
    {
      UShort_t nPacketWords=*p;
      UShort_t nId = p[1];
      if(nId == nOurId)
	{
	  UnpackPacket(p, rEvent);
	}
      p +=nPacketWords;
      nWords -= nPacketWords;
    }
  return kfTRUE;
}


void MyEventProcessor::UnpackPacket(TranslatorPointer<UShort_t> pEvent,
				    CEvent& rEvent)
{
  UInt_t nPacketSize = *pEvent;  // get number of words let to be read
  ++pEvent;++pEvent;++pEvent;++pEvent; // skip over Id info and Header words
  nPacketSize -=4;               // adjust words remaining

  Int_t nchannel;  
  while(nPacketSize>2)  // ignore end of block words
    {
      UInt_t word1 = *pEvent;   // read the first data word
      nchannel = word1 & 0x1f;  // get last five bits from word1 to get channel number
      ++pEvent;                 //advance read pionter
      UInt_t word2 = *pEvent;   // read the second data word
      UInt_t TDCValue = word2 & 0x7ff;  // get last twelve bits of word 2 = digitized value
      rEvent[Base + nchannel] = TDCValue;  // place the TDCValue into the [th] element of rbuf array
      ++pEvent;                 // advance read pionter
      nPacketSize -=2;          // adjust remaing word count

      // Below this line is a test line that can be uncommented to look at raw data
      cerr << "found a value of " <<TDCValue << " at channel " << nchannel <<endl;
    }
}
